<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfECoupon ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfECoupon
 * @subpackage Arrays
 */
class ArrayOfECoupon extends AbstractStructArrayBase
{
    /**
     * The ECoupon
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ECoupon[]
     */
    public $ECoupon;
    /**
     * Constructor method for ArrayOfECoupon
     * @uses ArrayOfECoupon::setECoupon()
     * @param \App|C\StructType\ECoupon[] $eCoupon
     */
    public function __construct(array $eCoupon = array())
    {
        $this
            ->setECoupon($eCoupon);
    }
    /**
     * Get ECoupon value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ECoupon[]|null
     */
    public function getECoupon()
    {
        return isset($this->ECoupon) ? $this->ECoupon : null;
    }
    /**
     * This method is responsible for validating the values passed to the setECoupon method
     * This method is willingly generated in order to preserve the one-line inline validation within the setECoupon method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateECouponForArrayConstraintsFromSetECoupon(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfECouponECouponItem) {
            // validation for constraint: itemType
            if (!$arrayOfECouponECouponItem instanceof \App|C\StructType\ECoupon) {
                $invalidValues[] = is_object($arrayOfECouponECouponItem) ? get_class($arrayOfECouponECouponItem) : sprintf('%s(%s)', gettype($arrayOfECouponECouponItem), var_export($arrayOfECouponECouponItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ECoupon property can only contain items of type \App|C\StructType\ECoupon, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ECoupon value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ECoupon[] $eCoupon
     * @return \App|C\ArrayType\ArrayOfECoupon
     */
    public function setECoupon(array $eCoupon = array())
    {
        // validation for constraint: array
        if ('' !== ($eCouponArrayErrorMessage = self::validateECouponForArrayConstraintsFromSetECoupon($eCoupon))) {
            throw new \InvalidArgumentException($eCouponArrayErrorMessage, __LINE__);
        }
        if (is_null($eCoupon) || (is_array($eCoupon) && empty($eCoupon))) {
            unset($this->ECoupon);
        } else {
            $this->ECoupon = $eCoupon;
        }
        return $this;
    }
    /**
     * Add item to ECoupon value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ECoupon $item
     * @return \App|C\ArrayType\ArrayOfECoupon
     */
    public function addToECoupon(\App|C\StructType\ECoupon $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ECoupon) {
            throw new \InvalidArgumentException(sprintf('The ECoupon property can only contain items of type \App|C\StructType\ECoupon, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ECoupon[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ECoupon|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ECoupon|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ECoupon|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ECoupon|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ECoupon|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ECoupon
     */
    public function getAttributeName()
    {
        return 'ECoupon';
    }
}
