<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfECouponBookCode ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfECouponBookCode
 * @subpackage Arrays
 */
class ArrayOfECouponBookCode extends AbstractStructArrayBase
{
    /**
     * The ECouponBookCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ECouponBookCode[]
     */
    public $ECouponBookCode;
    /**
     * Constructor method for ArrayOfECouponBookCode
     * @uses ArrayOfECouponBookCode::setECouponBookCode()
     * @param \App|C\StructType\ECouponBookCode[] $eCouponBookCode
     */
    public function __construct(array $eCouponBookCode = array())
    {
        $this
            ->setECouponBookCode($eCouponBookCode);
    }
    /**
     * Get ECouponBookCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ECouponBookCode[]|null
     */
    public function getECouponBookCode()
    {
        return isset($this->ECouponBookCode) ? $this->ECouponBookCode : null;
    }
    /**
     * This method is responsible for validating the values passed to the setECouponBookCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setECouponBookCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateECouponBookCodeForArrayConstraintsFromSetECouponBookCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfECouponBookCodeECouponBookCodeItem) {
            // validation for constraint: itemType
            if (!$arrayOfECouponBookCodeECouponBookCodeItem instanceof \App|C\StructType\ECouponBookCode) {
                $invalidValues[] = is_object($arrayOfECouponBookCodeECouponBookCodeItem) ? get_class($arrayOfECouponBookCodeECouponBookCodeItem) : sprintf('%s(%s)', gettype($arrayOfECouponBookCodeECouponBookCodeItem), var_export($arrayOfECouponBookCodeECouponBookCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ECouponBookCode property can only contain items of type \App|C\StructType\ECouponBookCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ECouponBookCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ECouponBookCode[] $eCouponBookCode
     * @return \App|C\ArrayType\ArrayOfECouponBookCode
     */
    public function setECouponBookCode(array $eCouponBookCode = array())
    {
        // validation for constraint: array
        if ('' !== ($eCouponBookCodeArrayErrorMessage = self::validateECouponBookCodeForArrayConstraintsFromSetECouponBookCode($eCouponBookCode))) {
            throw new \InvalidArgumentException($eCouponBookCodeArrayErrorMessage, __LINE__);
        }
        if (is_null($eCouponBookCode) || (is_array($eCouponBookCode) && empty($eCouponBookCode))) {
            unset($this->ECouponBookCode);
        } else {
            $this->ECouponBookCode = $eCouponBookCode;
        }
        return $this;
    }
    /**
     * Add item to ECouponBookCode value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ECouponBookCode $item
     * @return \App|C\ArrayType\ArrayOfECouponBookCode
     */
    public function addToECouponBookCode(\App|C\StructType\ECouponBookCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ECouponBookCode) {
            throw new \InvalidArgumentException(sprintf('The ECouponBookCode property can only contain items of type \App|C\StructType\ECouponBookCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ECouponBookCode[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ECouponBookCode|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ECouponBookCode|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ECouponBookCode|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ECouponBookCode|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ECouponBookCode|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ECouponBookCode
     */
    public function getAttributeName()
    {
        return 'ECouponBookCode';
    }
}
