<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWebClassFilter ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfWebClassFilter
 * @subpackage Arrays
 */
class ArrayOfWebClassFilter extends AbstractStructArrayBase
{
    /**
     * The WebClassFilter
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\WebClassFilter[]
     */
    public $WebClassFilter;
    /**
     * Constructor method for ArrayOfWebClassFilter
     * @uses ArrayOfWebClassFilter::setWebClassFilter()
     * @param \App|C\StructType\WebClassFilter[] $webClassFilter
     */
    public function __construct(array $webClassFilter = array())
    {
        $this
            ->setWebClassFilter($webClassFilter);
    }
    /**
     * Get WebClassFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\WebClassFilter[]|null
     */
    public function getWebClassFilter()
    {
        return isset($this->WebClassFilter) ? $this->WebClassFilter : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWebClassFilter method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWebClassFilter method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWebClassFilterForArrayConstraintsFromSetWebClassFilter(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWebClassFilterWebClassFilterItem) {
            // validation for constraint: itemType
            if (!$arrayOfWebClassFilterWebClassFilterItem instanceof \App|C\StructType\WebClassFilter) {
                $invalidValues[] = is_object($arrayOfWebClassFilterWebClassFilterItem) ? get_class($arrayOfWebClassFilterWebClassFilterItem) : sprintf('%s(%s)', gettype($arrayOfWebClassFilterWebClassFilterItem), var_export($arrayOfWebClassFilterWebClassFilterItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WebClassFilter property can only contain items of type \App|C\StructType\WebClassFilter, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WebClassFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\WebClassFilter[] $webClassFilter
     * @return \App|C\ArrayType\ArrayOfWebClassFilter
     */
    public function setWebClassFilter(array $webClassFilter = array())
    {
        // validation for constraint: array
        if ('' !== ($webClassFilterArrayErrorMessage = self::validateWebClassFilterForArrayConstraintsFromSetWebClassFilter($webClassFilter))) {
            throw new \InvalidArgumentException($webClassFilterArrayErrorMessage, __LINE__);
        }
        if (is_null($webClassFilter) || (is_array($webClassFilter) && empty($webClassFilter))) {
            unset($this->WebClassFilter);
        } else {
            $this->WebClassFilter = $webClassFilter;
        }
        return $this;
    }
    /**
     * Add item to WebClassFilter value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\WebClassFilter $item
     * @return \App|C\ArrayType\ArrayOfWebClassFilter
     */
    public function addToWebClassFilter(\App|C\StructType\WebClassFilter $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\WebClassFilter) {
            throw new \InvalidArgumentException(sprintf('The WebClassFilter property can only contain items of type \App|C\StructType\WebClassFilter, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WebClassFilter[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\WebClassFilter|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\WebClassFilter|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\WebClassFilter|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\WebClassFilter|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\WebClassFilter|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WebClassFilter
     */
    public function getAttributeName()
    {
        return 'WebClassFilter';
    }
}
