<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ECoupon StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ECoupon
 * @subpackage Structs
 */
class ECoupon extends ApiObject
{
    /**
     * The ECouponNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ECouponNumber;
    /**
     * The ExpiryDateGMT
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ExpiryDateGMT;
    /**
     * The StatusCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StatusCode;
    /**
     * The UsedDateGMT
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UsedDateGMT;
    /**
     * Constructor method for ECoupon
     * @uses ECoupon::setECouponNumber()
     * @uses ECoupon::setExpiryDateGMT()
     * @uses ECoupon::setStatusCode()
     * @uses ECoupon::setUsedDateGMT()
     * @param string $eCouponNumber
     * @param string $expiryDateGMT
     * @param string $statusCode
     * @param string $usedDateGMT
     */
    public function __construct($eCouponNumber = null, $expiryDateGMT = null, $statusCode = null, $usedDateGMT = null)
    {
        $this
            ->setECouponNumber($eCouponNumber)
            ->setExpiryDateGMT($expiryDateGMT)
            ->setStatusCode($statusCode)
            ->setUsedDateGMT($usedDateGMT);
    }
    /**
     * Get ECouponNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getECouponNumber()
    {
        return isset($this->ECouponNumber) ? $this->ECouponNumber : null;
    }
    /**
     * Set ECouponNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $eCouponNumber
     * @return \App|C\StructType\ECoupon
     */
    public function setECouponNumber($eCouponNumber = null)
    {
        // validation for constraint: string
        if (!is_null($eCouponNumber) && !is_string($eCouponNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eCouponNumber, true), gettype($eCouponNumber)), __LINE__);
        }
        if (is_null($eCouponNumber) || (is_array($eCouponNumber) && empty($eCouponNumber))) {
            unset($this->ECouponNumber);
        } else {
            $this->ECouponNumber = $eCouponNumber;
        }
        return $this;
    }
    /**
     * Get ExpiryDateGMT value
     * @return string|null
     */
    public function getExpiryDateGMT()
    {
        return $this->ExpiryDateGMT;
    }
    /**
     * Set ExpiryDateGMT value
     * @param string $expiryDateGMT
     * @return \App|C\StructType\ECoupon
     */
    public function setExpiryDateGMT($expiryDateGMT = null)
    {
        // validation for constraint: string
        if (!is_null($expiryDateGMT) && !is_string($expiryDateGMT)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expiryDateGMT, true), gettype($expiryDateGMT)), __LINE__);
        }
        $this->ExpiryDateGMT = $expiryDateGMT;
        return $this;
    }
    /**
     * Get StatusCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStatusCode()
    {
        return isset($this->StatusCode) ? $this->StatusCode : null;
    }
    /**
     * Set StatusCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $statusCode
     * @return \App|C\StructType\ECoupon
     */
    public function setStatusCode($statusCode = null)
    {
        // validation for constraint: string
        if (!is_null($statusCode) && !is_string($statusCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statusCode, true), gettype($statusCode)), __LINE__);
        }
        if (is_null($statusCode) || (is_array($statusCode) && empty($statusCode))) {
            unset($this->StatusCode);
        } else {
            $this->StatusCode = $statusCode;
        }
        return $this;
    }
    /**
     * Get UsedDateGMT value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUsedDateGMT()
    {
        return isset($this->UsedDateGMT) ? $this->UsedDateGMT : null;
    }
    /**
     * Set UsedDateGMT value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $usedDateGMT
     * @return \App|C\StructType\ECoupon
     */
    public function setUsedDateGMT($usedDateGMT = null)
    {
        // validation for constraint: string
        if (!is_null($usedDateGMT) && !is_string($usedDateGMT)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($usedDateGMT, true), gettype($usedDateGMT)), __LINE__);
        }
        if (is_null($usedDateGMT) || (is_array($usedDateGMT) && empty($usedDateGMT))) {
            unset($this->UsedDateGMT);
        } else {
            $this->UsedDateGMT = $usedDateGMT;
        }
        return $this;
    }
}
